/* Ejemplo de union con struct */
#include <stdio.h>

union uint_ucvec {
  unsigned int uint;
  unsigned char ucvec[4];
};

union uint_bytes {
  unsigned int uint;
  struct {
    unsigned char byte1;
    unsigned char byte2;
    unsigned char byte3;
    unsigned char byte4;
  } bytes;
};

union uint {
  unsigned int uint;
  unsigned char ucvec[4];
  struct {
    unsigned char byte1;
    unsigned char byte2;
    unsigned char byte3;
    unsigned char byte4;
  } bytes;
};


int main(void)
{
  int i;
  union uint_ucvec reg1;
  union uint_bytes reg2;
  union uint reg3;

  printf("Ingrese un entero sin signo: ");
  scanf("%u", &(reg1.uint));
  reg2.uint = reg1.uint;

  printf("Union uint_ucvec: ");
  for(i = 0; i < 4; i++)
    printf("%d ", reg1.ucvec[i]);
  printf("\n");

  printf("Union uint_bytes: ");
  printf("%d ", reg2.bytes.byte1);
  printf("%d ", reg2.bytes.byte2);
  printf("%d ", reg2.bytes.byte3);
  printf("%d \n", reg2.bytes.byte4);

  /* Union completa */
  for(i = 0; i < 4; i++)
    reg3.ucvec[i] = reg1.ucvec[i];

  printf("Union uint:       ");
  printf("%d ", reg3.bytes.byte1);
  printf("%d ", reg3.bytes.byte2);
  printf("%d ", reg3.bytes.byte3);
  printf("%d \n", reg3.bytes.byte4);


  return 0;
}
