/* Ejemplos de operadores a nivel de bits */
#include <stdio.h>

typedef unsigned char print_type;
void print_binary(print_type);

int main(void)
{
  unsigned char c1, c2;

  printf("Ingrese dos caracteres: ");
  scanf("%c %c", &c1, &c2);

  printf("\n      '%c' = ", c1);
  print_binary(c1);
  printf("      '%c' = ", c2);
  print_binary(c2);

  printf("\n'%c' & '%c' = ", c1, c2);
  print_binary(c1&c2);
  printf("\n'%c' | '%c' = ", c1, c2);
  print_binary(c1|c2);
  printf("\n'%c' ^ '%c' = ", c1, c2);
  print_binary(c1^c2);

  printf("\n     ~'%c' = ", c1);
  print_binary(~c1);

  return 0;
}

void print_binary(print_type val)
{
  print_type b, mask = 1<<(8*sizeof(print_type)-1);

  for(b = 1; b <= 8*sizeof(print_type); b++)
  {
    putchar(val & mask ? '1' : '0');
    val <<= 1;

    if(b % 8 == 0)
      putchar(' ');
  }

  putchar('\n');
}

