/* Imprime los bits de un entero sin signo */
#include <stdio.h>

typedef short unsigned print_type;
void print_binary(print_type);

int main(void)
{
  short unsigned val;

  printf("Ingrese un entero sin signo: ");
  scanf("%u", &val);
  print_binary(val);

  return 0;
}

void print_binary(print_type val)
{
  print_type b, mask = 1<<(8*sizeof(print_type)-1);

  printf("%7u = ", val);

  for(b = 1; b <= 8*sizeof(print_type); b++)
  {
    putchar(val & mask ? '1' : '0');
    val <<= 1;
/*    mask >>= 1;*/

    if(b % 8 == 0)
      putchar(' ');
  }

  putchar('\n');
}

